import tornado.ioloop
import tornado.web
import logging
from  airasia.OrderRelation import  OrderRelation;
from  airasia.AirasiaExchangeRate import  AirasiaExchangeRate;

class MainHandler( tornado.web.RequestHandler ):
    def get( self ):
        self.write( 'Tornado Says: Hello World !' )



#亚航的订单关联
class AirasiaOrderRelation(tornado.web.RequestHandler ):
    def   post(self):
        params = self.request.body.decode('utf-8');
        if params is None or params == "" :
            return  self.write("请求参数不能为空")
        print("开始关联，关联参数为---"+params);
        orderRelation = OrderRelation(params);
        self.write(orderRelation.worker());



#亚航的汇率
class AirasiaExchangeRateController(tornado.web.RequestHandler ):
    def post(self):
        airasiaExchangeRate = AirasiaExchangeRate();
        result = airasiaExchangeRate.worker().__str__();
        self.write(result);






application = tornado.web.Application( [
    ( r'/', MainHandler ), ( r'/orderRelation', AirasiaOrderRelation),( r'/airasiaExchangeRate', AirasiaExchangeRateController)
])

if __name__ == '__main__':
    application.listen( 8889 )
    print( 'Listening port : 8889 ...' )

    tornado.ioloop.IOLoop.instance().start()
    print( 'Tornado Instance started ...' )  